/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package statseditor;

import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

/**
 *
 * @author Matías
 */
public class EditorWindow extends javax.swing.JFrame {

    private StatisticManager statisticManager;
    private CreateEntryWindow createEntryWindow;

    /**
     * Creates new form EditorWindow
     */
    public EditorWindow() {

        this.statisticManager = new StatisticManager();

        try {

            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

        } catch (Exception e) {

        }

        initComponents();

        this.setLocationRelativeTo(null);
        this.setVisible(true);

        this.createEntryWindow = new CreateEntryWindow(this);

    }

    public StatisticManager getStatisticManager() {

        return this.statisticManager;

    }

    public void updateListModel() {

        this.entryList.setModel(this.statisticManager.generateListModel());

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        loadStatsButton = new javax.swing.JButton();
        saveStatsButton = new javax.swing.JButton();
        createEntryButton = new javax.swing.JButton();
        removeEntryButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        entryList = new javax.swing.JList<>();
        jLabel2 = new javax.swing.JLabel();
        playerNameField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        usgnIdField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        scoreField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        killsField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        deathsField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        serverTimeField = new javax.swing.JTextField();
        updateEntryButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("StatsEditor");
        setSize(new java.awt.Dimension(300, 400));

        loadStatsButton.setText("Load Stats");
        loadStatsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadStatsButtonActionPerformed(evt);
            }
        });

        saveStatsButton.setText("Save Stats");
        saveStatsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveStatsButtonActionPerformed(evt);
            }
        });

        createEntryButton.setText("Create Entry");
        createEntryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createEntryButtonActionPerformed(evt);
            }
        });

        removeEntryButton.setText("Remove Entry");
        removeEntryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeEntryButtonActionPerformed(evt);
            }
        });

        jLabel1.setText("Entry List");

        entryList.setModel(this.statisticManager.generateListModel());
        entryList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                entryListValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(entryList);

        jLabel2.setText("Player name");

        playerNameField.setEnabled(false);

        jLabel3.setText("U.S.G.N. ID");

        usgnIdField.setEnabled(false);

        jLabel4.setText("Score");

        scoreField.setEnabled(false);

        jLabel5.setText("Kills");

        killsField.setEnabled(false);

        jLabel6.setText("Deaths");

        deathsField.setEnabled(false);

        jLabel7.setText("Server time");

        serverTimeField.setEnabled(false);

        updateEntryButton.setText("Update Entry");
        updateEntryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateEntryButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(playerNameField)
                            .addComponent(usgnIdField)
                            .addComponent(scoreField)
                            .addComponent(killsField)
                            .addComponent(deathsField)
                            .addComponent(serverTimeField)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel3)
                                    .addComponent(jLabel4)
                                    .addComponent(jLabel5)
                                    .addComponent(jLabel6)
                                    .addComponent(jLabel7)
                                    .addComponent(updateEntryButton))
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(loadStatsButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(saveStatsButton, javax.swing.GroupLayout.DEFAULT_SIZE, 104, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(removeEntryButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(createEntryButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addGap(60, 60, 60)
                                .addComponent(jLabel2)))
                        .addGap(0, 65, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(loadStatsButton)
                    .addComponent(createEntryButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(saveStatsButton)
                    .addComponent(removeEntryButton))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(playerNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(usgnIdField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(scoreField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(killsField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(deathsField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(serverTimeField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(updateEntryButton)
                        .addGap(0, 11, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1)
                        .addContainerGap())))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void loadStatsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadStatsButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_loadStatsButtonActionPerformed

    private void saveStatsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveStatsButtonActionPerformed

        this.statisticManager.save();

    }//GEN-LAST:event_saveStatsButtonActionPerformed

    private void createEntryButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createEntryButtonActionPerformed

        this.createEntryWindow.openWindow();

    }//GEN-LAST:event_createEntryButtonActionPerformed

    private void entryListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_entryListValueChanged

        if (!evt.getValueIsAdjusting()) {

            Object selection = this.entryList.getSelectedValue();
            boolean enabled = selection instanceof Statistic;

            this.playerNameField.setEnabled(enabled);
            this.usgnIdField.setEnabled(enabled);
            this.deathsField.setEnabled(enabled);
            this.killsField.setEnabled(enabled);
            this.scoreField.setEnabled(enabled);
            this.serverTimeField.setEnabled(enabled);

            if (enabled) {

                Statistic stat = (Statistic) selection;

                this.playerNameField.setText(stat.getName());
                this.usgnIdField.setText(String.valueOf(stat.getUsgn()));
                this.deathsField.setText(String.valueOf(stat.getDeaths()));
                this.killsField.setText(String.valueOf(stat.getKills()));
                this.scoreField.setText(String.valueOf(stat.getScore()));
                this.serverTimeField.setText(String.valueOf(stat.getTime()));

            } else {

                this.playerNameField.setText("");
                this.usgnIdField.setText("");
                this.deathsField.setText("");
                this.killsField.setText("");
                this.scoreField.setText("");
                this.serverTimeField.setText("");

            }

        }

    }//GEN-LAST:event_entryListValueChanged

    private void removeEntryButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeEntryButtonActionPerformed

        Object selection = this.entryList.getSelectedValue();

        if (selection instanceof Statistic) {

            this.statisticManager.removeStatistic((Statistic) selection);
            this.updateListModel();

        }

    }//GEN-LAST:event_removeEntryButtonActionPerformed

    private void updateEntryButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateEntryButtonActionPerformed

        Object selection = this.entryList.getSelectedValue();

        if (selection instanceof Statistic) {

            Statistic stat = (Statistic) selection;

            String name = this.playerNameField.getText();
            int usgn;
            int score;
            int kills;
            int deaths;
            int serverTime;

            try {

                usgn = Integer.parseInt(this.usgnIdField.getText());

            } catch (NumberFormatException e) {

                JOptionPane.showMessageDialog(null, "Invalid U.S.G.N. Id", "Stats Editor", JOptionPane.WARNING_MESSAGE);
                return;

            }

            try {

                score = Integer.parseInt(this.scoreField.getText());

            } catch (NumberFormatException e) {

                JOptionPane.showMessageDialog(null, "Invalid score", "Stats Editor", JOptionPane.WARNING_MESSAGE);
                return;

            }

            try {

                kills = Integer.parseInt(this.killsField.getText());

            } catch (NumberFormatException e) {

                JOptionPane.showMessageDialog(null, "Invalid kills", "Stats Editor", JOptionPane.WARNING_MESSAGE);
                return;

            }

            try {

                deaths = Integer.parseInt(this.deathsField.getText());

            } catch (NumberFormatException e) {

                JOptionPane.showMessageDialog(null, "Invalid deaths", "Stats Editor", JOptionPane.WARNING_MESSAGE);
                return;

            }

            try {

                serverTime = Integer.parseInt(this.serverTimeField.getText());;

            } catch (NumberFormatException e) {

                JOptionPane.showMessageDialog(null, "Invalid server time", "Stats Editor", JOptionPane.WARNING_MESSAGE);
                return;

            }

            if (usgn > 0) {

                if (name.length() > 0) {

                    stat.setName(name);
                    stat.setUsgn(usgn);
                    stat.setScore(score);
                    stat.setKills(kills);
                    stat.setDeaths(deaths);
                    stat.setTime(serverTime);

                    this.updateListModel();
                    this.entryList.setSelectedValue(stat, true);

                } else {

                    JOptionPane.showMessageDialog(null, "Must contain a name", "Stats Editor", JOptionPane.WARNING_MESSAGE);

                }

            } else {

                JOptionPane.showMessageDialog(null, "U.S.G.N. Id must be higher than zero", "Stats Editor", JOptionPane.WARNING_MESSAGE);

            }

        }

    }//GEN-LAST:event_updateEntryButtonActionPerformed

    private void playerNameChanged() {

        Object selection = this.entryList.getSelectedValue();

        if (selection instanceof Statistic) {
            System.out.println(this.playerNameField.getText());
        }

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton createEntryButton;
    private javax.swing.JTextField deathsField;
    private javax.swing.JList<String> entryList;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField killsField;
    private javax.swing.JButton loadStatsButton;
    private javax.swing.JTextField playerNameField;
    private javax.swing.JButton removeEntryButton;
    private javax.swing.JButton saveStatsButton;
    private javax.swing.JTextField scoreField;
    private javax.swing.JTextField serverTimeField;
    private javax.swing.JButton updateEntryButton;
    private javax.swing.JTextField usgnIdField;
    // End of variables declaration//GEN-END:variables
}
