/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package statseditor;

import java.io.RandomAccessFile;
import java.util.Map.Entry;
import java.util.HashMap;
import javax.swing.DefaultListModel;

/**
 *
 * @author Matías
 */
public class StatisticManager {

    private HashMap<Integer, Statistic> statisticsTable;

    public StatisticManager() {

        this.load();

    }

    public void load() {

        this.statisticsTable = new HashMap<Integer, Statistic>();

        try {

            RandomAccessFile statisticsFile = new RandomAccessFile("sys/stats/userstats.dat", "rw");

            if (statisticsFile.readLine().equals("userstats alpha")) {

                while (statisticsFile.getFilePointer() < statisticsFile.length()) {

                    String name = statisticsFile.readLine();
                    long sizeLeft = statisticsFile.length() - statisticsFile.getFilePointer();

                    if (sizeLeft >= 20) {

                        Statistic stat = new Statistic();

                        stat.setName(name);
                        stat.setUsgn(Integer.reverseBytes(statisticsFile.readInt()));
                        stat.setScore(Integer.reverseBytes(statisticsFile.readInt()));
                        stat.setKills(Integer.reverseBytes(statisticsFile.readInt()));
                        stat.setDeaths(Integer.reverseBytes(statisticsFile.readInt()));
                        stat.setTime(Integer.reverseBytes(statisticsFile.readInt()));

                        this.statisticsTable.put(stat.getUsgn(), stat);

                    }

                }

            }

            statisticsFile.close();

        } catch (Exception e) {

        }

    }

    public void save() {

        try {

            RandomAccessFile statisticsFile = new RandomAccessFile("sys/stats/userstats.dat", "rw");

            statisticsFile.setLength(0);
            statisticsFile.writeBytes("userstats alpha\n");

            for (Entry<Integer, Statistic> entry : this.statisticsTable.entrySet()) {

                Statistic stat = entry.getValue();

                statisticsFile.writeBytes(stat.getName() + "\n");
                statisticsFile.writeInt(Integer.reverseBytes(stat.getUsgn()));
                statisticsFile.writeInt(Integer.reverseBytes(stat.getScore()));
                statisticsFile.writeInt(Integer.reverseBytes(stat.getKills()));
                statisticsFile.writeInt(Integer.reverseBytes(stat.getDeaths()));
                statisticsFile.writeInt(Integer.reverseBytes(stat.getTime()));

            }

            statisticsFile.close();

        } catch (Exception e) {

        }

    }

    public Statistic getByUsgn(int usgn) {

        return this.statisticsTable.get(usgn);

    }

    public void putStatistic(Statistic statistic) {

        int usgn = statistic.getUsgn();

        if (usgn > 0) {

            this.statisticsTable.put(statistic.getUsgn(), statistic);

        }

    }

    public void removeStatistic(Statistic statistic) {

        this.statisticsTable.remove(statistic.getUsgn());

    }

    public DefaultListModel generateListModel() {

        DefaultListModel listModel = new DefaultListModel();

        for (Entry<Integer, Statistic> entry : this.statisticsTable.entrySet()) {

            listModel.addElement(entry.getValue());

        }

        return listModel;

    }

}
